> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Add one or more components to project

POST https://example.itential.io/automation-studio/projects/{projectId}/components/add
Content-Type: application/json

Adds one or more components to Project.

Reference: https://docs.itential.com/itential-cloud/api-reference/automation-studio/add-components-to-project

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `projectId` (string, required) — Project identifier

### Body (application/json)

This endpoint expects an object.

- `components` (list of object, required) — A list of member components in the project
  - `iid` (integer, optional) — Incrementing integer ID
  - `type` (enum, optional) — String denoting the type of component
    - Allowed values: `workflow`, `jsonForm`, `mopAnalyticTemplate`, `mopCommandTemplate`, `template`, `transformation`
  - `reference` (string, optional)
  - `folder` (string, optional)
- `mode` (enum, optional) — Specifies the operation to perform on the component. Defaults to create.
  - Allowed values: `move`, `copy`, `duplicate`, `create`

## Response

### 200

Updated project

- `message` (string, optional)
- `data` (list of object, optional)
  - `_id` (string, optional) — A string representation of a MongoDB ObjectId
  - `iid` (integer, optional) — Incrementing integer ID
  - `name` (string, optional) — Project name
  - `description` (string, optional) — A free-form block of text for describing project intent and function
  - `members` (list of object, optional)
    - `type` (enum, required)
      - Allowed values: `account`, `group`
    - `reference` (string, required) — A string representation of a MongoDB ObjectId
    - `role` (enum, required)
      - Allowed values: `owner`, `editor`, `operator`, `viewer`
    - `missing` (boolean, optional)
    - `username` (string, optional)
    - `name` (string, optional)
    - `provenance` (string, optional)
  - `accessControl` (object, optional)
    - `read` (list of string, required)
    - `execute` (list of string, required)
    - `write` (list of string, required)
    - `manage` (list of string, required)
  - `componentIidIndex` (integer, optional) — Read-only property providing incrementing integer ID values for child components within a project
  - `components` (list of object, optional) — A list of member components in the project
    - `iid` (integer, optional) — Incrementing integer ID
    - `type` (enum, optional) — String denoting the type of component
      - Allowed values: `workflow`, `jsonForm`, `mopAnalyticTemplate`, `mopCommandTemplate`, `template`, `transformation`
    - `reference` (string, optional)
    - `folder` (string, optional)
  - `folders` (list of object or object, optional) — A list of folders and their members
    - object
      - `nodeType` (enum, required) — String denoting the nodeType of the folder node
        - Allowed values: `folder`, `component`
      - `name` (string, required) — Folder name
      - `children` (list of any or object, required)
        - object
          - `iid` (integer, required) — Incrementing integer ID
          - `nodeType` (enum, required) — String denoting the nodeType of the folder node
            - Allowed values: `folder`, `component`
          - `type` (enum, optional) — String denoting the type of component
            - Allowed values: `workflow`, `jsonForm`, `mopAnalyticTemplate`, `mopCommandTemplate`, `template`, `transformation`
          - `reference` (string, optional)
    - object
      - `iid` (integer, required) — Incrementing integer ID
      - `nodeType` (enum, required) — String denoting the nodeType of the folder node
        - Allowed values: `folder`, `component`
      - `type` (enum, optional) — String denoting the type of component
        - Allowed values: `workflow`, `jsonForm`, `mopAnalyticTemplate`, `mopCommandTemplate`, `template`, `transformation`
      - `reference` (string, optional)
  - `created` (string, optional) — ISO Date String
  - `createdBy` (any, optional)
  - `lastUpdated` (string, optional) — ISO Date String
  - `lastUpdatedBy` (any, optional)
  - `versionHistory` (list of object, optional)
    - `versionNumber` (integer, required)
    - `commitMessage` (string, required)
    - `author` (string, required)
    - `branchName` (string, required)
  - `gitConfiguration` (object, optional)
    - `connectionType` (enum, required)
      - Allowed values: `GitHub`, `GitLab`
    - `repositoryPath` (string, required)
    - `branchName` (string, required)
    - `projectPath` (string, required)
- `metadata` (object, optional)
  - `newComponents` (list of any, optional) — Components added
  - `failedComponents` (list of any, optional) — Components failed to add
  - `idMap` (list of any, optional) — Id map for original and cloned component

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{
  "components": [
    {}
  ]
}
```

**Response**

```json
{
  "message": "string",
  "data": [
    {
      "_id": "62a1f3d2ebedfc54e6e0065c",
      "iid": 1,
      "name": "Firewall Service Provisioning",
      "description": "This project is used at Acme Corp as the foundation of some major parts of our business process.",
      "members": [
        {
          "type": "account",
          "reference": "62a1f3d2ebedfc54e6e0065c",
          "role": "owner",
          "missing": true,
          "username": "admin@pronghorn",
          "name": "admin",
          "provenance": "Pronghorn"
        }
      ],
      "accessControl": {
        "read": [
          "account:67d3108eddcf3e66cc0efbac"
        ],
        "execute": [
          "account:67d3108eddcf3e66cc0efbac"
        ],
        "write": [
          "account:67d3108eddcf3e66cc0efbac"
        ],
        "manage": [
          "account:67d3108eddcf3e66cc0efbac"
        ]
      },
      "componentIidIndex": 1,
      "components": [
        {
          "iid": 1,
          "type": "workflow",
          "reference": "1Ac4B2268489019745B5baa4",
          "folder": "string"
        }
      ],
      "folders": [
        {
          "children": [
            null
          ],
          "name": "folder-1",
          "nodeType": "folder"
        }
      ],
      "created": "2019-11-25T22:51:39.201Z",
      "lastUpdated": "2019-11-25T22:51:39.201Z",
      "versionHistory": [
        {
          "versionNumber": 1,
          "commitMessage": "string",
          "author": "admin@pronghorn",
          "branchName": "master"
        }
      ],
      "gitConfiguration": {
        "connectionType": "GitHub",
        "repositoryPath": "Itential Open Source",
        "branchName": "master",
        "projectPath": "Projects"
      }
    }
  ],
  "metadata": {
    "newComponents": [
      "string"
    ],
    "failedComponents": [
      "string"
    ],
    "idMap": [
      "string"
    ]
  }
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/automation-studio/projects/projectId/components/add"

payload = { "components": [{}] }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/automation-studio/projects/projectId/components/add';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"components":[{}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/automation-studio/projects/projectId/components/add"

	payload := strings.NewReader("{\n  \"components\": [\n    {}\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/automation-studio/projects/projectId/components/add")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"components\": [\n    {}\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/automation-studio/projects/projectId/components/add")
  .header("Content-Type", "application/json")
  .body("{\n  \"components\": [\n    {}\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/automation-studio/projects/projectId/components/add', [
  'body' => '{
  "components": [
    {}
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/automation-studio/projects/projectId/components/add");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"components\": [\n    {}\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["components": [[]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/automation-studio/projects/projectId/components/add")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```